
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

 	EXTERNDEF lstrlenCrZ:PROTO  :DWORD,:DWORD
	
		comment 
		In: offset of starting position of the search in the line
						 1 to max len of the line,Base 1
		In: adress of the string in which the search is made
		In: adress of the string to be search
		In: 1 for text search (minus = majus),0 for binary search
				----- more than InStr ----------------------
		In: adress of a list of caracters authorized at the left of the word
					sample     LeftLimit db " ",9,"<",0
					The list must be zero terminated
		In: adress of a list of caracters authorized at the right of the word
					sample     RightLimit db " ",9,">",0
					The list must be zero terminated							
		
		out eax
		eax = 0,failed
		eax != 0,offset of string position found ,base 1
		
		The lenght of the search is limited by lstrlenCrZ at MAX_PATH +1
		The line can be zero terminated or Cr (13) terminated,The two are valid		
		
		
		
		
	
	
	

      ; 

    .code


; ########################################################################
InStrLimited proc Start:DWORD,AdrPerdu:DWORD,AdrChercher:DWORD,Methode:DWORD,\
			AdrAutoriseAvant:DWORD,AdrAutoriseApres:DWORD
			
	Local LongCont       :DWORD
	Local PointCont      :DWORD
	Local LongCherche    :DWORD
	Local DeplaceMax     :DWORD
	local retour         :DWORD 
	Local Position	:DWORD
	
	Pushad  
	
	mov retour,1	;par dfaut russite
	mov eax,Start
	mov Position,eax
	;---------------------- verify it is possible --------------------------
	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.endif	
	invoke lstrlenCrZ,AdrPerdu,MAX_PATH +1

	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.endif
	mov LongCont,eax	
	invoke lstrlenCrZ,AdrChercher,MAX_PATH + 1
	.if eax < 1
		mov retour,0
		jmp FindechercherMot
	.else
	mov LongCherche,eax
	mov ecx,LongCont
	cmp eax,ecx
	jle ValidData
	mov retour,0
	jmp FindechercherMot			
	.endif
			
	;la chaine de recherche doit etre <= en taille a l'autre
ValidData: 
	;------- vrifier que la chaine est contenu dans ce qui reste
	mov eax, Position        ;relatif a la chaine
	add eax,LongCherche	     ;longueur de la chaine cherche
	dec eax		     
	.if eax > LongCont
		mov retour,0
		jmp FindechercherMot
	.endif
	mov ecx,LongCont
	inc ecx           ;sinon -1 en sortie pour zero dep
	sub ecx,eax
	mov DeplaceMax,ecx ;nombre de dplacements possible du pointeur de recherche

	; les donnes sont valides 
	;InsTxt Message," les donnes sont valides",0 
	;INVOKE     MessageBox, Hwnd, addr Message, addr titre, MB_YESNO 

	cld
	push Position
	Pop PointCont
	dec  PointCont        
	mov esi,AdrPerdu
	add esi,Position           ;1 car pointeur 0
	dec esi		     ;esi chaine contenant + position de depart -1
	dec esi                  ;est incremente de nouveau par progresse contenant
	mov edi,AdrChercher        ;di sur contenu ?
ProgresseAdrPerdu:
	inc esi
	inc PointCont           ;position de trouver 
	xor ebx,ebx
	xor eax,eax
	xor edx,edx             ;dl byte cherche
ProgresseContenu:
	mov al,byte ptr [esi+ebx]
	.if Methode == 1        ;en majuscules
		.if eax > 96 && eax < 123
			sub al,32
		.endif
	.endif
	mov dl,byte ptr [edi+ebx]
	.if Methode ==1        ;en majuscules
		.if edx > 96 && edx < 123
			sub dl,32
		.endif
	.endif

	inc ebx
	cmp al,dl
	jnz NegatifResult 
	cmp ebx,LongCherche
	jnz ProgresseContenu   ;continu la comparaison
	jmp ChaineTrouve
NegatifResult:
	dec DeplaceMax     ;decremente compteur dep
	jnz ProgresseAdrPerdu
	mov retour,0		;not found
	jmp FindechercherMot
ChaineTrouve:
	mov eax,PointCont     ;found at position
	mov retour,eax	;//////////////// chaine identique trouv /////////////////////////////
	mov Position,eax
	;-------------- Limits ? ---------------------------------------
	;------- List of limits must be zero terminated
	;------------------- left limite -----------------------------------------
	mov esi,AdrPerdu
	.if Position == 1
		jmp limiteSup		;Word is at the start of phrase,accept left limit
	.endif
	add esi,Position
	sub esi,2
	mov al,[esi]
	mov edi,AdrAutoriseAvant
	;---------------------------------------------------------------------------
	;-------- compar al aux caractres de la liste
	mov dl,[edi]
	.if dl == 0
		jmp limiteSup      ;There is no left limit,accept the left limit
	.endif
	@@:
	mov dl,[edi]
	.if al == dl
		jmp limiteSup	     ;identique accept
	.else
		inc edi
		mov dl,[edi]
		.if dl == 0
			mov eax,LongCherche		;failed ,caracter not in the list
			add Position,eax
			jmp ValidData
		.endif
		jmp @B
	.endif
	
	;------------------------------ Right Limit ---------------------------
	limiteSup:
	mov eax,Position
	dec eax
	add eax,LongCherche	
	.if eax >= LongCont			;> is only to secure,it's =
		jmp FindechercherMot		;Word at the end of a phrase,accept right limit 
	.endif
	;--------
	mov esi,AdrPerdu
	add esi,Position
	dec esi
	add esi,LongCherche
	mov al,[esi]
	.if al == 0
		;caracter right limit is 0,accept
		jmp FindechercherMot
	.endif
	mov edi,AdrAutoriseApres
	mov dl,[edi]
	.if dl == 0
		jmp FindechercherMot      ;right limit empty,accept
	.endif
	@@:
	mov dl,[edi]
	.if al == dl
		jmp FindechercherMot	     ;identique , chaine valide
	.else
		inc edi
		mov dl,[edi]
		.if dl == 0
			mov eax,LongCherche		;failed,caracter not in the list
			add Position,eax
			jmp ValidData
		.endif
		jmp @B
	.endif
	

FindechercherMot: 
popad
mov eax,retour     
ret

InStrLimited endp

; #########################################################################

end
