
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

       include \masm32\include\windows.inc
	EXTERNDEF lstrlenCrZ:PROTO  :DWORD,:DWORD
	
		Comment 
		In: offset of starting position of the search in the line
						 1 to max len of the line,Base 1
		In: adress of the string in which the search is made
		In: adress of the string to be search
		In: 1 for text search (minus = majus),0 for binary search
		
		out eax
		eax = 0,failed
		eax != 0,offset of string position found ,base 1
		
		The lenght of the search is limited by lstrlenCrZ at MAX_PATH +1
		The line can be zero terminated or Cr (13) terminated,The two are valid
		
	

      ; 

    .code


; ########################################################################
InStrg proc Start:DWORD,Contenant:DWORD,Chercher:DWORD,Methode:DWORD
; Works as the VB one 
	Local LongCont       :DWORD
	Local PointCont      :DWORD
	Local LongCherche    :DWORD
	Local DeplaceMax     :DWORD
	local retour         :DWORD 
	Pushad  
	mov retour,0	;par dfaut chec
	mov eax,Start
		;------------ is it possible ? --------------------
	.if eax < 1
		mov retour,0
		jmp FinChercherChaine
	.endif

	invoke lstrlenCrZ,Contenant,MAX_PATH +1

	.if eax < 1
		mov retour,0
		jmp FinChercherChaine
	.endif
	mov LongCont,eax
	
	invoke lstrlenCrZ,Chercher,MAX_PATH + 1
	.if eax < 1
		mov retour,0
		jmp FinChercherChaine
	.endif
	;la chaine de recherche doit etre <= en taille a l'autre
	mov LongCherche,eax
	mov ecx,LongCont
	cmp eax,ecx
	jle ValidData
		mov retour,0
		jmp FinChercherChaine
ValidData: 
	;Performing a search is possible
	mov eax, Start        ;relatif a la chaine
	add eax,LongCherche
	dec eax
	.if eax > LongCont
		mov retour,0
		jmp FinChercherChaine
	.endif
	mov ecx,LongCont
	inc ecx           ;sinon -1 en sortie pour zero dep
	sub ecx,eax
	mov DeplaceMax,ecx ;maximum moves of the search pointer

	; les donnes sont valides 

	cld
	push Start
	Pop PointCont
	dec  PointCont        
	mov esi,Contenant
	add esi,Start           ;1 car pointer 0
	dec esi		     
	dec esi                 
	mov edi,Chercher        
ProgresseContenant:
	inc esi
	inc PointCont           ;possible position found 
	xor ebx,ebx
	xor eax,eax
	xor edx,edx             ;dl byte 
ProgresseContenu:
	mov al,byte ptr [esi+ebx]	;byte of string to search in
	.if Methode == 1        ;change minus to MAJUS
		.if eax > 96 && eax < 123
			sub al,32
		.endif
	.endif
	mov dl,byte ptr [edi+ebx]	;byte of string to search
	.if Methode ==1        ;change minus to MAJUS
		.if edx > 96 && edx < 123
			sub dl,32
		.endif
	.endif

	inc ebx
	cmp al,dl
	jnz NegatifResult 
	cmp ebx,LongCherche
	jnz ProgresseContenu   ;continue to compare
	jmp ChaineTrouve
NegatifResult:
	dec DeplaceMax     ;decrease the counter of moves
	jnz ProgresseContenant
	mov retour,0		;not found
	jmp FinChercherChaine
ChaineTrouve:
	mov eax,PointCont     ;found at position
	mov retour,eax

FinChercherChaine: 
popad
mov eax,retour     
ret
InStrg endp

; #########################################################################

end